=== debian/changelog ===
rock-master-19.06-planning-arvand-herd (0.20150408-1~stretch) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-planning/planning-arvand_herd.git
  * branch: refs/heads/master
  * commit: ea34aff173f67bddcca1f8cc2abb17c56f915bb7
  * tag: 

 -- Packaging Daemon <rock-dev@dfki.de>  Mon, 08 Jul 2019 16:00:11 +0200
