=== debian/control ===
Source: rock-master-19.06-planning-arvand-herd
Section: science
Priority: extra
Maintainer: Rock Packaging Daemon <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, build-essential, cmake, python-dev, rock-master-19.06-base-cmake
Standards-Version: 3.9.2
Homepage: http://rock-robotics.org
#Vcs-Git: git://git.debian.org/collab-maint/bla.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/bla.git;a=summary

Package: rock-master-19.06-planning-arvand-herd
Architecture: any
Depends: ${shlibs:Depends}, rock-master-19.06-base-cmake, cmake, build-essential, python-dev
Description: ArvandHerd
 This in an integration package for the ArvandHerd planner (see url below) as submitted to IPC-2013.
  No additional functionality is provided, adaptation to the original sources are made only to include the planner into the
  build infrastructure.
